package uloha1;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.TransformerException;
import org.dom4j.io.DOMReader;
import org.dom4j.io.OutputFormat;
import org.dom4j.io.XMLWriter;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

public class DemoModifyDOMdom4j {

    private static Document doc;

    public static void main(String[] args) throws IOException, SAXException, ParserConfigurationException, TransformerException, Exception {

        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        // Pomoci tovarni tridy ziskame instanci DocumentBuilderu
        DocumentBuilder builder = factory.newDocumentBuilder();
        // DocumentBuilder pouzijeme pro zpracovani XML dokumentu
        // a ziskame model dokumentu ve formatu W3C DOM
        doc = builder.parse("test/uloha1/people.xml");

        Element people = doc.getDocumentElement();

        NodeList persons = people.getElementsByTagName("person");

        for (int i = 0; i < persons.getLength(); i++) {
            Element person = (Element) persons.item(i);
            Element personSalary = (Element) person.getElementsByTagName("salary").item(0);
            double salary = Double.parseDouble(personSalary.getTextContent());

            if (salary < 10000) {
                Element personSurname = (Element) person.getElementsByTagName("surname").item(0);
                System.out.println(personSurname.getTextContent() + " will be deleted");
                people.removeChild(person);
                i--;
            }
        }

        serializetoXML(new FileOutputStream("out.xml"), "UTF-8");

    }

    public static void serializetoXML(OutputStream out, String aEncodingScheme) throws Exception {
        OutputFormat outformat = OutputFormat.createPrettyPrint();
        outformat.setEncoding(aEncodingScheme);
        XMLWriter writer = new XMLWriter(out, outformat);

        DOMReader xmlReader = new DOMReader();
        org.dom4j.Document dom4jDoc = xmlReader.read(doc);

        writer.write(dom4jDoc);
        writer.flush();
    }
}
